/*
 * ppplicznik -- counter of ppp connections with many features
 * Copyright (C) 2001 Artur Siekielski <gruesome@go2.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef koszty_h
#define koszty_h

#pragma interface

#include <ctime>
#include <fstream>
#include <vector>
#include <string>
#include <sstream>
#include <iostream>
#include <map>

#include "ppp.h"
#include "ekran.h"

using namespace std;

struct rule
{
	int od_godziny;
	int do_godziny;
	int od_dnia;
	int do_dnia;
	float koszt_impulsu;
	int dlugosc_impulsu;
};

class konfiguracja
{
	vector<rule> reguly;
	rule* regula_na_teraz;
	rule swieto;
	vector< pair<int, int> > lista_swiat;
	bool run;
	bool bez_sprawdzenia;
	bool stt;
	bool hostip;
	bool rozlacz;
	bool rozlacz_enabled;
	bool wykres;
	bool kolory_ramka_bold;
	bool kolory_napisy_bold;
	bool kolory_dane_bold;
	bool kolory_wyk_od_bold;
	bool kolory_wyk_wys_bold;
	bool kolory_limit_bold;
	bool limit;
	int ur_przed;
	int rozlacz_kiedy;
	int doliczane;
	int ile_sr;
	int kolory_ramka[2];
	int kolory_napisy[2];
	int kolory_dane[2];
	int kolory_wyk_od[2];
	int kolory_wyk_wys[2];
	int kolory_limit[2];
	int gorna_przerwa;
	int wyk_max;
	int wyk_one;
	int beg_month;
	int hours;
	float hour_cost;
	float ile_podatku;
	time_t t_mod;
	float km_mies;
	float km_koszt_ost_pol;
	float limit_ile;
	float km_wys_ost_pol;
	float km_ode_ost_pol;
	float km_dzien;
	typedef void (konfiguracja::*wskm)(const string&);
	map<string, wskm> S;
	map<string, int> dni;
	void ustawMape();
	void ustawReguleNaTeraz();
	void czytajBegMon(const string&);
	void czytajCoWysw(const string&);
	void czytajDolicz(const string&);
	void czytajHostIp(const string&);
	void czytajHours(const string&);
	void czytajKolory(const string&);
	void czytajKoloryHelp(istringstream&, int&, bool&);
	void czytajLimit(const string&);
	void czytajLock(const string&);
	void czytajPlik(const string&);
	void czytajPodatek(const string&);
	void czytajRozlacz(const string&);
	void czytajRozlaczKiedy(const string&);
	void czytajSwieta(const string&);
	void czytajTerm(const string&);
	void czytajUruchom(const string&);
	void czytajWykres(const string&);
	void czytajZasady(const string&);
	void czytajZmienne();
	char** co_uru;
	char** co_uru_rozl;
	string plik_konf;
	string pierwszy_ur;
	string pierwszy_ur_rozl;
	string plik_lock;
	string zmienna_ip;
	string zmienna_host;
	vector<int> cowysw;
	int mspec;
	int yspec;
public:
	tm akt;
	enum wypis
	{
		wszystko,
		miesiac,
		specific
	};
	wypis wy;
	konfiguracja();
	void parsujPlik();
	int coIleTeraz();
	float zwrocKoszt() { return regula_na_teraz->koszt_impulsu; }
	friend ostream& operator<<(ostream& strumien, konfiguracja& konf);
	friend class program;
	friend class polaczenie;
	friend class ekran;
	friend class pppst;
};

class polaczenie
{
	time_t poczatek;
	tm poczatek_tm;
	time_t koniec;
	tm koniec_tm;
	int trwanie;
	int do_nastepnego;
	int impulsy;
	float koszt;
	void konwertuj();
	public:
	static konfiguracja konf;
	static pppst pepepe;
	polaczenie();
	void oblicz();
	void uruchom();
	void uruchom_rozl();
	friend ostream& operator<<(ostream& strumien, const polaczenie& connection);
	friend fstream& operator<<(fstream& plik, const polaczenie& connection);
	friend fstream& operator>>(fstream& plik, polaczenie& connection);
	friend class program;
	friend class ekran;
};


#endif
