/*
 * ppplicznik -- counter of ppp connections with many features
 * Copyright (C) 2001 Artur Siekielski <gruesome@go2.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef main_h
#define main_h

#pragma interface

#include "koszty.h"

class program
{
	fstream log_odczyt;
	fstream log_zapis;
	ekran* ekranik;
	bool zlicz;
	bool zapisywac;
	string plik_logow;
	string plik_lock;
	void obliczKosztyMiesieczne();
	bool czyDobraData(const polaczenie&);
public:
	program();
	polaczenie aktualne;
	~program();
	void sprawdzLock();
	void zliczaj();
	void printHelp();
	void wyswietlPlik();
	void sprawdzPolaczenie();
	int czytajOpcje(int, char**);
	void probujLiczyc();
	void wypiszPodsumowanie();
	friend class polaczenie;
};

class error {
	const string s;
public:
	error(const string ss): s(ss) {}
	string what() const { return s; }
};

#endif

