/*
 * ppplicznik -- counter of ppp connections with many features
 * Copyright (C) 2001 Artur Siekielski <gruesome@go2.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#pragma implementation

#include "ppp.h"
#include "koszty.h"
#include "loc.h"
#include "main.h"

using namespace std;

pppst::pppst()
{
	akt_odebrane = bajty_odebrane = akt_wyslane = bajty_wyslane = sredni = sredni_wys = 0;
	ppp_s = socket(AF_INET, SOCK_DGRAM, 0);
	memset(&req, 0, sizeof(req));
	req.stats_ptr = reinterpret_cast<char*>(&req.stats);
	strcpy(req.ifr__name, "ppp0");
}

void pppst::ustawTablice()
{	
	s.resize(polaczenie::konf.ile_sr);
	s2.resize(polaczenie::konf.ile_sr);
}


bool pppst::czyAktywny()
{
	return ioctl(ppp_s, SIOCGPPPSTATS, &req) >= 0;
}

void pppst::wezStatystyki()
{
	if (ioctl(ppp_s, SIOCGPPPSTATS, &req) >= 0) {
		++licznik;
		st = req.stats;
		akt_odebrane = st.p.ppp_ibytes - bajty_odebrane;
		bajty_odebrane = st.p.ppp_ibytes;
		akt_wyslane = st.p.ppp_obytes - bajty_wyslane;
		bajty_wyslane = st.p.ppp_obytes;
		sredni = bajty_odebrane / licznik;
		sredni_wys = bajty_wyslane / licznik;
		if (polaczenie::konf.wykres) {
			for (size_t i = 0; i < (s.size() - 1); ++i) {
				s[i] = s[i + 1];
				s2[i] = s2[i + 1];
			}
			s[s.size() - 1] = akt_odebrane;
			s2[s2.size() - 1] = akt_wyslane;
		}
	}
	else
		if (polaczenie::konf.bez_sprawdzenia == false)
			throw error(gettext("Connection terminated."));
}
